diff --git a/sys/vm/vm_map.c b/sys/vm/vm_map.c
index 890fd147bf48..bd3bcf397261 100644
--- a/sys/vm/vm_map.c
+++ b/sys/vm/vm_map.c
@@ -100,6 +100,10 @@ __FBSDID("$FreeBSD$");
 #include <vm/swap_pager.h>
 #include <vm/uma.h>
 
+#ifdef CHERI_CAPREVOKE
+#include <sys/caprevoke.h>
+#endif
+
 /*
  *	Virtual memory maps provide for the mapping, protection,
  *	and sharing of virtual memory objects.  In addition,
@@ -135,6 +139,7 @@ static int vm_map_zinit(void *mem, int ize, int flags);
 static void _vm_map_init(vm_map_t map, pmap_t pmap, vm_offset_t min,
     vm_offset_t max);
 static void vm_map_entry_deallocate(vm_map_entry_t entry, boolean_t system_map);
+static void vm_map_entry_delete(vm_map_t map, vm_map_entry_t entry);
 static void vm_map_entry_dispose(vm_map_t map, vm_map_entry_t entry);
 static void vm_map_entry_unwire(vm_map_t map, vm_map_entry_t entry);
 static int vm_map_growstack(vm_map_t map, vm_offset_t addr,
@@ -150,6 +155,7 @@ static int vm_map_stack_locked(vm_map_t map, vm_offset_t addrbos,
     int cow);
 static void vm_map_wire_entry_failure(vm_map_t map, vm_map_entry_t entry,
     vm_offset_t failed_addr);
+static vm_map_entry_t vm_map_entry_create(vm_map_t map);
 
 #define	ENTRY_CHARGED(e) ((e)->cred != NULL || \
     ((e)->object.vm_object != NULL && (e)->object.vm_object->cred != NULL && \
@@ -275,6 +281,9 @@ vm_map_zinit(void *mem, int size, int flags)
 	memset(map, 0, sizeof(*map));
 	mtx_init(&map->system_mtx, "vm map (system)", NULL, MTX_DEF | MTX_DUPOK);
 	sx_init(&map->lock, "vm map (user)");
+#ifdef CHERI_CAPREVOKE
+	cv_init(&map->vm_caprev_cv, "vmcaprev");
+#endif
 	return (0);
 }
 
@@ -361,6 +370,11 @@ vmspace_dofree(struct vmspace *vm)
 	 */
 	shmexit(vm);
 
+#ifdef CHERI_CAPREVOKE
+	/* Drop our explicit handle to the caprevoke shadow object */
+	vm->vm_map.vm_caprev_sh = NULL;
+#endif
+
 	/*
 	 * Lock the map, to wait out all other references to it.
 	 * Delete all of the mappings and pages they hold, then call
@@ -401,6 +415,86 @@ vmspace_exitfree(struct proc *p)
 	vmspace_free(vm);
 }
 
+static int coexecve_cleanup_margin_up = 0x10000;
+SYSCTL_INT(_debug, OID_AUTO, coexecve_cleanup_margin_up, CTLFLAG_RWTUN,
+    &coexecve_cleanup_margin_up, 0,
+    "Maximum hole size for segments growing up when cleaning up after colocated processes");
+static int coexecve_cleanup_margin_down = MAXSSIZ;
+SYSCTL_INT(_debug, OID_AUTO, coexecve_cleanup_margin_down, CTLFLAG_RWTUN,
+    &coexecve_cleanup_margin_down, 0,
+    "Maximum hole size for segments growing down when cleaning up after colocated processes");
+
+static void
+vm_map_entry_abandon(vm_map_t map, vm_map_entry_t old_entry)
+{
+	vm_map_entry_t entry, prev, next;
+	vm_offset_t start, end;
+	boolean_t found, grown_down;
+	int rv;
+
+	start = old_entry->start;
+
+	if (start != 0)
+		vm_map_lookup_entry(map, start-1, &prev);
+	else
+		prev = &map->header;
+	next = vm_map_entry_succ(old_entry);
+
+	end = old_entry->end;
+	grown_down = old_entry->eflags & MAP_ENTRY_GROWS_DOWN;
+	vm_map_entry_delete(map, old_entry);
+
+	/*
+	 * Try to cover the "holes" between abandoned entries, so that
+	 * vm_map_try_merge_entries() can coalesce them.  Use much larger
+	 * threshold for stacks.
+	 */
+	if (prev != &map->header && prev->object.vm_object == NULL &&
+	    prev->protection == PROT_NONE &&
+	    start > prev->end && start - prev->end <=
+	    ((grown_down != 0) ?
+	    coexecve_cleanup_margin_down : coexecve_cleanup_margin_up)) {
+		start = prev->end;
+	}
+
+	if (next != &map->header && next->object.vm_object == NULL &&
+	    next->protection == PROT_NONE &&
+	    end < next->start && next->start - end <=
+	    (((next->eflags & MAP_ENTRY_GROWS_DOWN) != 0) ?
+	    coexecve_cleanup_margin_down : coexecve_cleanup_margin_up)) {
+		end = next->start;
+	}
+
+	rv = vm_map_insert(map, NULL, 0, start, end,
+	    PROT_NONE, PROT_NONE, MAP_NOFAULT | MAP_DISABLE_SYNCER | MAP_DISABLE_COREDUMP);
+	KASSERT(rv == KERN_SUCCESS,
+	    ("%s: vm_map_insert() failed with error %d\n", __func__, rv));
+
+	found = vm_map_lookup_entry(map, start, &entry);
+	KASSERT(found == TRUE,
+	    ("%s: vm_map_insert() returned false\n", __func__));
+
+	KASSERT(entry->protection == PROT_NONE,
+	    ("%s: protection %d\n", __func__, entry->protection));
+	KASSERT(entry->max_protection == PROT_NONE,
+	    ("%s: max_protection %d\n", __func__, entry->max_protection));
+	KASSERT(entry->inheritance == VM_INHERIT_DEFAULT,
+	    ("%s: inheritance %d\n", __func__, entry->inheritance));
+	KASSERT(entry->wired_count == 0,
+	    ("%s: wired_count %d\n", __func__, entry->wired_count));
+	KASSERT(entry->cred == NULL,
+	    ("%s: cred %p\n", __func__, entry->cred));
+
+	/*
+	 * Preserve this particular flag for the purpose of future coalescing
+	 * by another vm_map_entry_abandon() run.
+	 */
+	if (grown_down)
+		entry->eflags |= MAP_ENTRY_GROWS_DOWN;
+
+	vm_map_try_merge_entries(map, prev, entry);
+}
+
 void
 vmspace_exit(struct thread *td)
 {
@@ -941,6 +1035,11 @@ _vm_map_init(vm_map_t map, pmap_t pmap, vm_offset_t min, vm_offset_t max)
 	map->timestamp = 0;
 	map->busy = 0;
 	map->anon_loc = 0;
+
+#ifdef CHERI_CAPREVOKE
+	map->vm_caprev_st = CAPREVST_NONE;	/* and epoch 0 */
+#endif
+
 #ifdef DIAGNOSTIC
 	map->nupdates = 0;
 #endif
@@ -2261,10 +2360,16 @@ static bool
 vm_map_mergeable_neighbors(vm_map_entry_t prev, vm_map_entry_t entry)
 {
 
+#ifdef notyet
 	KASSERT((prev->eflags & MAP_ENTRY_NOMERGE_MASK) == 0 ||
 	    (entry->eflags & MAP_ENTRY_NOMERGE_MASK) == 0,
 	    ("vm_map_mergeable_neighbors: neither %p nor %p are mergeable",
 	    prev, entry));
+#else
+	if ((prev->eflags & MAP_ENTRY_NOMERGE_MASK) != 0 &&
+	    (entry->eflags & MAP_ENTRY_NOMERGE_MASK) != 0)
+	    return (false);
+#endif
 	return (prev->end == entry->start &&
 	    prev->object.vm_object == entry->object.vm_object &&
 	    (prev->object.vm_object == NULL ||
@@ -3883,8 +3988,8 @@ vm_map_entry_delete(vm_map_t map, vm_map_entry_t entry)
  *	Deallocates the given address range from the target
  *	map.
  */
-int
-vm_map_delete(vm_map_t map, vm_offset_t start, vm_offset_t end)
+static int
+_vm_map_delete(vm_map_t map, vm_offset_t start, vm_offset_t end, bool abandon)
 {
 	vm_map_entry_t entry;
 	vm_map_entry_t first_entry;
@@ -3974,12 +4079,28 @@ vm_map_delete(vm_map_t map, vm_offset_t start, vm_offset_t end)
 		 * will be set in the wrong object!)
 		 */
 		vm_map_log("remove", entry);
-		vm_map_entry_delete(map, entry);
+		if (abandon)
+			vm_map_entry_abandon(map, entry);
+		else
+			vm_map_entry_delete(map, entry);
 		entry = next;
 	}
 	return (KERN_SUCCESS);
 }
 
+int
+vm_map_abandon_and_delete(vm_map_t map, vm_offset_t start, vm_offset_t end)
+{
+
+	return (_vm_map_delete(map, start, end, true));
+}
+
+int
+vm_map_delete(vm_map_t map, vm_offset_t start, vm_offset_t end)
+{
+
+	return (_vm_map_delete(map, start, end, false));
+}
 /*
  *	vm_map_remove:
  *
@@ -4260,6 +4381,13 @@ vmspace_fork(struct vmspace *vm1, vm_ooffset_t *fork_charge)
 	vm2->vm_taddr = vm1->vm_taddr;
 	vm2->vm_daddr = vm1->vm_daddr;
 	vm2->vm_maxsaddr = vm1->vm_maxsaddr;
+
+#ifdef CHERI_CAPREVOKE
+	vm2->vm_map.vm_caprev_st   = vm1->vm_map.vm_caprev_st;
+	vm2->vm_map.vm_caprev_sh   = vm1->vm_map.vm_caprev_sh;
+	vm2->vm_map.vm_caprev_shva = vm1->vm_map.vm_caprev_shva;
+#endif
+
 	vm_map_lock(old_map);
 	if (old_map->busy)
 		vm_map_wait_busy(old_map);
diff --git a/sys/vm/vm_map.h b/sys/vm/vm_map.h
index 915d3e79e8be..e1c072ff19b1 100644
--- a/sys/vm/vm_map.h
+++ b/sys/vm/vm_map.h
@@ -71,6 +71,7 @@
 #include <sys/lock.h>
 #include <sys/sx.h>
 #include <sys/_mutex.h>
+#include <sys/condvar.h>
 
 /*
  *	Types defined:
@@ -200,6 +201,12 @@ struct vm_map {
 	struct vm_map_entry header;	/* List of entries */
 	struct sx lock;			/* Lock for map data */
 	struct mtx system_mtx;
+#ifdef CHERI_CAPREVOKE
+	struct cv vm_caprev_cv;         /* (c) Cap. rev. is single file */
+	uint64_t vm_caprev_st;          /* Capability revocation state */
+	vm_object_t vm_caprev_sh;       /* My caprevoke shadow object */
+	vm_offset_t vm_caprev_shva;     /* caprevoke shadow posn. in map */
+#endif
 	int nentries;			/* Number of entries */
 	vm_size_t size;			/* virtual size */
 	u_int timestamp;		/* Version number */
@@ -446,6 +453,7 @@ vm_map_entry_read_succ(void *token, struct vm_map_entry *const clone,
 #ifdef _KERNEL
 boolean_t vm_map_check_protection (vm_map_t, vm_offset_t, vm_offset_t, vm_prot_t);
 vm_map_t vm_map_create(pmap_t, vm_offset_t, vm_offset_t);
+int vm_map_abandon_and_delete(vm_map_t, vm_offset_t, vm_offset_t);
 int vm_map_delete(vm_map_t, vm_offset_t, vm_offset_t);
 int vm_map_find(vm_map_t, vm_object_t, vm_ooffset_t, vm_offset_t *, vm_size_t,
     vm_offset_t, int, vm_prot_t, vm_prot_t, int);
@@ -506,6 +514,7 @@ int vm_map_wire_locked(vm_map_t map, vm_offset_t start, vm_offset_t end,
     int flags);
 long vmspace_swap_count(struct vmspace *vmspace);
 void vm_map_entry_set_vnode_text(vm_map_entry_t entry, bool add);
+
 #endif				/* _KERNEL */
 #endif				/* _VM_MAP_ */
 // CHERI CHANGES START
diff --git a/sys/vm/vm_mmap.c b/sys/vm/vm_mmap.c
index 75a40f74af54..f45826bbb09a 100644
--- a/sys/vm/vm_mmap.c
+++ b/sys/vm/vm_mmap.c
@@ -128,6 +128,9 @@ SYSCTL_INT(_vm, OID_AUTO, imply_prot_max, CTLFLAG_RWTUN, &imply_prot_max, 0,
 static int log_wxrequests = 0;
 SYSCTL_INT(_vm, OID_AUTO, log_wxrequests, CTLFLAG_RWTUN, &log_wxrequests, 0,
     "Log requests for PROT_WRITE and PROT_EXEC");
+static int abandon_on_munmap = 1;
+SYSCTL_INT(_vm, OID_AUTO, abandon_on_munmap, CTLFLAG_RWTUN, &abandon_on_munmap, 0,
+    "Add abandoned entries on munmap(2)");
 #if __has_feature(capabilities)
 SYSCTL_DECL(_security_cheri);
 SYSCTL_NODE(_security_cheri, OID_AUTO, mmap, CTLFLAG_RW, 0, "mmap");
@@ -1101,7 +1104,10 @@ kern_munmap(struct thread *td, uintptr_t addr0, size_t size)
 		}
 	}
 #endif
-	vm_map_delete(map, addr, addr + size);
+	if (abandon_on_munmap)
+		vm_map_abandon_and_delete(map, addr, addr + size);
+	else
+		vm_map_delete(map, addr, addr + size);
 
 #ifdef HWPMC_HOOKS
 	if (__predict_false(pmc_handled)) {
@@ -1473,6 +1479,21 @@ kern_mincore(struct thread *td, uintptr_t addr0, size_t len,
 				    pmap_is_referenced(m) ||
 				    (m->a.flags & PGA_REFERENCED) != 0)
 					mincoreinfo |= MINCORE_REFERENCED_OTHER;
+#ifdef MINCORE_MAYHAVECAP
+				/*
+				 * The pmap may have told us that this
+				 * particular mapping is already capdirty,
+				 * and if so don't bother with the more
+				 * elaborate probes and especially not with
+				 * the expensive pmap_tc_capdirty.
+				 */
+				if ((mincoreinfo & MINCORE_MAYHAVECAP) != 0 ||
+					((m->a.flags & PGA_CAPSTORED) != 0) ||
+					((m->flags & VPO_PASTCAPSTORE) != 0) ||
+					pmap_tc_capdirty(m) ||
+					((m->a.flags & PGA_CAPSTORED) != 0))
+					mincoreinfo |= MINCORE_MAYHAVECAP;
+#endif
 			}
 			if (object != NULL)
 				VM_OBJECT_WUNLOCK(object);
@@ -2198,3 +2219,19 @@ vm_mmap_to_errno(int rv)
 //   "change_comment": ""
 // }
 // CHERI CHANGES END
+
+/* This is almost surely the wrong place for this */
+int
+sys_caprevoke(struct thread *td, struct caprevoke_args *uap)
+{
+	return ENOSYS;
+}
+int
+sys_caprevoke_shadow(struct thread *td, struct caprevoke_shadow_args *uap)
+{
+	return ENOSYS;
+}
+int sys_caprevoke_entire_shadow_cap(struct thread *td, struct caprevoke_entire_shadow_cap_args *uap)
+{
+	return ENOSYS;
+}
diff --git a/sys/vm/vm_object.c b/sys/vm/vm_object.c
index 1cc1221073ff..1690659b6994 100644
--- a/sys/vm/vm_object.c
+++ b/sys/vm/vm_object.c
@@ -1391,6 +1391,21 @@ vm_object_shadow(vm_object_t *object, vm_ooffset_t *offset, vm_size_t length,
 		VM_OBJECT_WUNLOCK(result);
 	}
 
+#if defined(OBJ_NOSTORETAGS) && defined(OBJ_NOLOADTAGS)
+	/*
+	 * XXX CHERI: This does not feel like the right place to do this,
+	 * and yet here we are.
+	 *
+	 * When shadowing a DEFAULT object type, if that object is marked
+	 * with tag-inhibit bits, then so should the shadow-casting object.
+	 * However, when shadowing non-DEFAULT objects, we often want to
+	 * permit tag stores, so don't inherit the inhibits.
+	 */
+	if (source->type == OBJT_DEFAULT)
+		result->flags |= source->flags
+				& (OBJ_NOLOADTAGS | OBJ_NOSTORETAGS);
+#endif
+
 	/*
 	 * Return the new things
 	 */
diff --git a/sys/vm/vm_page.c b/sys/vm/vm_page.c
index 1c6a1515e047..4f27bdb5a0d3 100644
--- a/sys/vm/vm_page.c
+++ b/sys/vm/vm_page.c
@@ -1796,6 +1796,17 @@ vm_page_replace_hold(vm_page_t mnew, vm_object_t object, vm_pindex_t pindex,
 	 */
 	if (pmap_page_is_write_mapped(mnew))
 		vm_object_set_writeable_dirty(object);
+
+#ifdef PGA_CAPSTORED
+	/*
+	 * Copy across capability tracking flags
+	 */
+	if (mold->a.flags & PGA_CAPSTORED)
+		vm_page_capdirty(mnew);
+	if (mold->oflags & VPO_PASTCAPSTORE)
+		mnew->oflags |= VPO_PASTCAPSTORE;
+#endif
+
 	dropped = vm_page_drop(mold, VPRC_OBJREF) == VPRC_OBJREF;
 	vm_page_xunbusy(mold);
 
diff --git a/sys/vm/vm_page.h b/sys/vm/vm_page.h
index fd1ebc470ca0..04f06dfb5c85 100644
--- a/sys/vm/vm_page.h
+++ b/sys/vm/vm_page.h
@@ -295,6 +295,9 @@ struct vm_page {
 #define	VPO_SWAPSLEEP	0x02		/* waiting for swap to finish */
 #define	VPO_UNMANAGED	0x04		/* no PV management for page */
 #define	VPO_SWAPINPROG	0x08		/* swap I/O in progress on page */
+#if __has_feature(capabilities)
+#define	VPO_PASTCAPSTORE 0x10	/* This page had capabilities in the past */
+#endif
 
 /*
  * Busy page implementation details.
@@ -431,6 +434,13 @@ extern struct mtx_padalign pa_lock[];
  * PGA_SWAP_FREE is used to defer freeing swap space to the pageout daemon
  * when the context that dirties the page does not have the object write lock
  * held.
+ *
+ * PGA_CAPSTORED indicates that a capability was written to this page since
+ * the last time this bit (and the underlying architectural permission) was
+ * cleared.  No locks are required to update this bit; it may be set by the
+ * MD layer arbitrarily and cleared by the MI layer as desired.  The MI
+ * layer must call pmap_sync_capdirty with threads stopped if it expects an
+ * accurate view.
  */
 #define	PGA_WRITEABLE	0x0001		/* page may be mapped writeable */
 #define	PGA_REFERENCED	0x0002		/* page has been referenced */
@@ -442,6 +452,9 @@ extern struct mtx_padalign pa_lock[];
 #define	PGA_NOSYNC	0x0080		/* do not collect for syncer */
 #define	PGA_SWAP_FREE	0x0100		/* page with swap space was dirtied */
 #define	PGA_SWAP_SPACE	0x0200		/* page has allocated swap space */
+#if __has_feature(capabilities)
+#define	PGA_CAPSTORED	0x0400
+#endif
 
 #define	PGA_QUEUE_OP_MASK	(PGA_DEQUEUE | PGA_REQUEUE | PGA_REQUEUE_HEAD)
 #define	PGA_QUEUE_STATE_MASK	(PGA_ENQUEUED | PGA_QUEUE_OP_MASK)
@@ -833,6 +846,30 @@ vm_page_aflag_set(vm_page_t m, uint16_t bits)
 	atomic_set_32(addr, val);
 }
 
+#if 0
+/*
+ * Atomically read and clear some bits in a page's aflags field.  Unlike
+ * vm_page_aflag_clear, this reports the contents of the aflags field before
+ * mutation, allowing for a race-free observation and reset of status.
+ *
+ * This used to be used with capability revocation, but is now unused.
+ *
+ */
+static inline int
+vm_page_aflag_xclear_acq(vm_page_t m, uint16_t bits)
+{
+	uint32_t *addr, n, o;
+
+	addr = (void *)&m->aflags;
+	o = *addr;
+	do {
+		n = o & ~(bits << VM_PAGE_AFLAG_SHIFT);
+	} while (!atomic_fcmpset_acq_32(addr, &o, n));
+
+	return (o >> VM_PAGE_AFLAG_SHIFT) & 0xFFFF;
+}
+#endif
+
 /*
  *	vm_page_dirty:
  *
@@ -855,6 +892,16 @@ vm_page_dirty(vm_page_t m)
 #endif
 }
 
+static __inline void
+vm_page_capdirty(vm_page_t m)
+{
+#ifdef PGA_CAPSTORED
+	vm_page_aflag_set(m, PGA_CAPSTORED);
+#else
+	(void)m;
+#endif
+}
+
 /*
  *	vm_page_undirty:
  *
diff --git a/tools/build/cross-build/include/linux/limits.h b/tools/build/cross-build/include/linux/limits.h
index e31b92c37b81..4af87e5345b7 100644
--- a/tools/build/cross-build/include/linux/limits.h
+++ b/tools/build/cross-build/include/linux/limits.h
@@ -100,10 +100,6 @@
 #warning __USE_POSIX not defined
 #endif
 
-#if defined __GNUC__ && !defined _GCC_LIMITS_H_
-#error "GCC limits not included"
-#endif
-
 #ifndef __OFF_T_MATCHES_OFF64_T
 #error "Expected 64-bit off_t"
 #endif
diff --git a/tools/cheribsdbox/Makefile b/tools/cheribsdbox/Makefile
index 45f86a7cd844..e3e0d3139c75 100644
--- a/tools/cheribsdbox/Makefile
+++ b/tools/cheribsdbox/Makefile
@@ -74,6 +74,7 @@ CRUNCH_SHLIBS+=	-pthread
 
 # ktrace:
 CRUNCH_LIBS+=	-lsysdecode
+CRUNCH_LIBS+= -lprocstat -lelf
 
 # login/su (could theoretically use static_libpam but that will probably not work)
 CRUNCH_SHLIBS+= -lpam -lbsm
@@ -216,6 +217,7 @@ CRUNCH_PROGS_usr.bin+= \
 		basename \
 		bmake \
 		bzip2 \
+		cpuset \
 		diff \
 		dirname \
 		du \
@@ -238,6 +240,7 @@ CRUNCH_PROGS_usr.bin+= \
 		mktemp \
 		nc \
 		passwd \
+		procstat \
 		resizewin \
 		sed \
 		seq \
diff --git a/usr.bin/procstat/procstat_vm.c b/usr.bin/procstat/procstat_vm.c
index aa8bc3a10096..d35a043b3546 100644
--- a/usr.bin/procstat/procstat_vm.c
+++ b/usr.bin/procstat/procstat_vm.c
@@ -53,7 +53,7 @@ procstat_vm(struct procstat *procstat, struct kinfo_proc *kipp)
 
 	ptrwidth = 2*sizeof(void *) + 2;
 	if ((procstat_opts & PS_OPT_NOHEADER) == 0)
-		xo_emit("{T:/%5s %*s %*s %3s %4s %4s %3s %3s %-5s %-2s %-s}\n",
+		xo_emit("{T:/%5s %*s %*s %5s %4s %4s %3s %3s %-5s %-2s %-s}\n",
 		    "PID", ptrwidth, "START", ptrwidth, "END", "PRT", "RES",
 		    "PRES", "REF", "SHD", "FLAG", "TP", "PATH");
 
@@ -77,8 +77,12 @@ procstat_vm(struct procstat *procstat, struct kinfo_proc *kipp)
 		    "r" : "-");
 		xo_emit("{d:write/%s}", kve->kve_protection & KVME_PROT_WRITE ?
 		    "w" : "-");
-		xo_emit("{d:exec/%s} ", kve->kve_protection & KVME_PROT_EXEC ?
+		xo_emit("{d:exec/%s}", kve->kve_protection & KVME_PROT_EXEC ?
 		    "x" : "-");
+		xo_emit("{d:rcap/%s}",
+		    kve->kve_protection & KVME_PROT_READCAPS ? "L" : "-");
+		xo_emit("{d:wcap/%s} ",
+		    kve->kve_protection & KVME_PROT_WRITECAPS ? "S" : "-");
 		xo_open_container("kve_protection");
 		xo_emit("{en:read/%s}", kve->kve_protection & KVME_PROT_READ ?
 		    "true" : "false");
@@ -86,6 +90,10 @@ procstat_vm(struct procstat *procstat, struct kinfo_proc *kipp)
 		    "true" : "false");
 		xo_emit("{en:exec/%s}", kve->kve_protection & KVME_PROT_EXEC ?
 		    "true" : "false");
+		xo_emit("{en:rcap/%s}",
+		    kve->kve_protection & KVME_PROT_READCAPS ? "true" : "false");
+		xo_emit("{en:wcap/%s}",
+		    kve->kve_protection & KVME_PROT_WRITECAPS ? "true" : "false");
 		xo_close_container("kve_protection");
 		xo_emit("{:kve_resident/%4d/%d} ", kve->kve_resident);
 		xo_emit("{:kve_private_resident/%4d/%d} ",
